#include<stdio.h>
#include<stdlib.h>
#include<math.h>

int foo(int N, int *a, int *b, int *c, int *d) {
  double tmp, total = 0;
  #pragma omp parallel reduction(+:total)
  {
    #pragma omp sections
    {
      #pragma omp section
      {
        #pragma omp parallel for reduction(+:total)
        for (int i = 0; i < N; i++) {
          #pragma omp atomic
          a[b[i]] += b[i];
          total += b[i];
        }
      }
      #pragma omp section
      {
        #pragma omp parallel private(tmp) reduction(+:total)
        {
          #pragma omp for schedule(static) nowait
          for (int i = 0; i < N; i++) {
            tmp = c[i];
            c[i] = d[i];
            d[i] = tmp;
            total += c[i];
          }
          #pragma omp for schedule(static)
          for (int i = 0; i < N; i++) {
            total += d[i];
          }
        }
      }
    }
  }
  return total;
}

int main(int argc, char ** argv) {
  if (argc != 2) {
    printf("Usage: %s <N>\n", argv[0]);
    return EXIT_SUCCESS;
  }
  int N = 2 * atoi(argv[1]);
  int* a = malloc(N * sizeof(int));
  int* b = malloc(N * sizeof(int));
  int* c = malloc(N * sizeof(int));
  int* d = malloc(N * sizeof(int));
  for (int i = 0; i < N; i++) {
    a[i] = c[i] = i;
    d[i] = N - i;
    b[i] = 2 * (i / 2) + 1 - (i % 2);
  }
  int total = foo(N, a, b, c, d);
  double error = 0;
  for (int i = 0; i < N; i++) {
    error += fabs(b[i] - (2 * (i / 2) + 1 - (i % 2)));
    error += fabs(c[i] - N + i);
    error += fabs(d[i] - i);
    error += fabs(a[i] - 2 * i);
  }
  error += fabs(total - N * (3 * N - 1) / 2);
  printf("error: %f\n", error);
}
